From 2c455e8972b1c2ac17efb1642e0ce2e23dc6368e Mon Sep 17 00:00:00 2001
From: Xavier Simonart <xsimonar@redhat.com>
Date: Tue, 23 Apr 2024 13:53:31 +0200
Subject: [PATCH 4/6] controller: Fix deletion of container parent port.

Flows were not properly removed when parent port of a container port
was deleted.

Signed-off-by: Xavier Simonart <xsimonar@redhat.com>
Signed-off-by: Numan Siddique <numans@ovn.org>
---
 controller/binding.c  | 1 +
 controller/physical.c | 3 ++-
 2 files changed, 3 insertions(+), 1 deletion(-)

diff --git a/controller/binding.c b/controller/binding.c
index 0712d7030..8043656e7 100644
--- a/controller/binding.c
+++ b/controller/binding.c
@@ -2741,6 +2741,7 @@ handle_deleted_vif_lport(const struct sbrec_port_binding *pb,
          * deleted 'pb' type is LP_VIF. */
         struct binding_lport *c_lport;
         LIST_FOR_EACH (c_lport, list_node, &lbinding->binding_lports) {
+            remove_local_lports(c_lport->pb->logical_port, b_ctx_out);
             if (!release_binding_lport(b_ctx_in->chassis_rec, c_lport,
                                        !b_ctx_in->ovnsb_idl_txn,
                                        b_ctx_out)) {
diff --git a/controller/physical.c b/controller/physical.c
index 953c20f59..dc66b2250 100644
--- a/controller/physical.c
+++ b/controller/physical.c
@@ -1026,7 +1026,8 @@ put_local_common_flows(uint32_t dp_key,
         put_resubmit(OFTABLE_LOG_TO_PHY, ofpacts_p);
         put_stack(MFF_IN_PORT, ofpact_put_STACK_POP(ofpacts_p));
         ofctrl_check_and_add_flow_metered(flow_table, OFTABLE_SAVE_INPORT, 100,
-                                          0, &match, ofpacts_p, hc_uuid,
+                                          parent_pb->header_.uuid.parts[0],
+                                          &match, ofpacts_p, &pb->header_.uuid,
                                           NX_CTLR_NO_METER, NULL, false);
     }
 }
-- 
2.39.5

